<?php

declare(strict_types = 1);

namespace Drupal\ui_skins\CssVariable;

use Drupal\Component\Plugin\PluginManagerInterface;

/**
 * Defines an interface for Css variable plugin managers.
 */
interface CssVariablePluginManagerInterface extends PluginManagerInterface {

  /**
   * {@inheritdoc}
   *
   * @return \Drupal\ui_skins\Definition\CssVariableDefinition|null
   *   The plugin definition. NULL if not found.
   *
   * @SuppressWarnings(PHPMD.BooleanArgumentFlag)
   */
  public function getDefinition($plugin_id, $exception_on_invalid = TRUE);

  /**
   * {@inheritdoc}
   *
   * @return \Drupal\ui_skins\Definition\CssVariableDefinition[]
   *   The plugins definitions.
   */
  public function getDefinitions();

  /**
   * Filter plugins by the modules and the selected theme and its parents.
   *
   * Also update the default value from configuration.
   *
   * @param string $theme
   *   The theme to filter the plugins against.
   *
   * @return \Drupal\ui_skins\Definition\CssVariableDefinition[]
   *   The list of filtered definitions.
   */
  public function getDefinitionsForTheme(string $theme): array;

}
